#include <cstddef>
#include <vector>

#include <filter/filter/filter.hpp>

namespace Filter {
IFilter::IFilter(std::size_t size) {
  impulseResponse.reserve(size);
}

void IFilter::ConvolveIQ(const std::vector<float>& input, std::vector<float>& output) {
  // TODO: SIMD

  auto itIn = input.begin();
  auto itOut = output.begin();

  while (itIn != input.end()) {
    for (float h : impulseResponse) {
      // I
      *itOut += *itIn * h;
      itIn++;
      itOut++;

      // Q
      *itOut += *itIn * h;
      itIn++;
      itOut++;
    }
  }
}
} // namespace Filter