#include <cmath>
#include <numbers>

#include <filter/window/hamming_window.hpp>

namespace Filter {
HammingWindow::HammingWindow(std::size_t width) {
  window.reserve(width);
  for (std::size_t i = 0; i < width; i++) {
    window[i] = (25 / 46.0) - (21 / 46.0) * std::cos(2 * std::numbers::pi * i / width);
  }
}
} // namespace Filter